// -*- C++ -*-

#pragma once

#include "stdinc.h"
#include <complex>


namespace goopax {

namespace impl {

using std::max;
using std::min;

template<typename T, typename Enable = typename goopax::impl::enable_if<(goopax::impl::is_arithmetic<T>::value && !goopax::impl::is_same<T, bool>::value)>::type>
gpu_type<T> min(gpu_type<T> a, gpu_type<T> b);
template<typename T, typename Enable = typename goopax::impl::enable_if<(goopax::impl::is_arithmetic<T>::value && !goopax::impl::is_same<T, bool>::value)>::type>
gpu_type<T> max(gpu_type<T> a, gpu_type<T> b);
}
}

namespace goopax {
namespace impl {
using std::abs;
using std::acos;
using std::acosh;
using std::asin;
using std::asinh;
using std::atan;
using std::atan2;
using std::atanh;
using std::cbrt;
using std::ceil;
using std::cos;
using std::cosh;
using std::erf;
using std::erfc;
using std::exp;
using std::exp2;
using std::floor;
using std::isfinite;
using std::isinf;
using std::isnan;
using std::isnormal;
using std::log;
using std::log2;
using std::max;
using std::min;
using std::pow;
using std::round;
using std::sin;
using std::sinh;
using std::sqrt;
using std::tan;
using std::tanh;
using std::tgamma;

using std::operator*;
using std::operator/;
using std::operator+;
using std::operator-;
using std::operator>>;
using std::operator<<;
//using std::operator &;
//using std::operator |;
//using std::operator ^;

//      using std::operator ~;
using std::abs;
using std::ceil;
using std::floor;
using std::max;
using std::min;
using std::round;
}
}
